from Products.CMFCore.utils import getToolByName
from Products.CMFFormController.FormAction import FormActionKey
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin
from Products.Archetypes.public import listTypes

from StringIO import StringIO

from Products.CMFDynamicViewFTI.migrate import migrateFTIs

from Products.ImageMag.config import *

def install(self):
    """Install ImageMag: Install content types, skin layer, install the
    stylesheet, set up global properties, enable the portal factory and
    set up form controller actions for the widget actions
    """

    out = StringIO()

    print >> out, "Installing ImageMag"

    # Install types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    print >> out, "Installed types"

    # Install skin
    install_subskin(self, out, GLOBALS)
    print >> out, "Installed skin"

    # Migrate FTI, to make sure we get the necessary infrastructure for the
    # 'display' menu to work.
    migrated = migrateFTIs(self, product=PROJECTNAME)
    print >>out, "Switched to DynamicViewFTI: %s" % ', '.join(migrated)

    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    for add_type in ('ImageMag'):
        if add_type not in types:
            types.append(add_type)
            factory.manage_setPortalFactoryTypes(listOfTypeIds = types)

    print >> out, "Added ImageMag contents to portal_factory"

    portal_props = getToolByName(self, 'portal_properties')
    siteProperties = getattr(portal_props, 'site_properties')

    # Add to default_page_types
    defaultPageTypes = list(siteProperties.getProperty('default_page_types'))
    if 'ImageMag' not in defaultPageTypes:
        defaultPageTypes.append('ImageMag')
        siteProperties.manage_changeProperties(default_page_types = defaultPageTypes)

    return out.getvalue()

def uninstall(self, reinstall):
    out = StringIO()

    if not reinstall:
        print >> out, "Uninstalling ImageMag"

        portal_props = getToolByName(self, 'portal_properties')
        siteProperties = getattr(portal_props, 'site_properties')

        # Remove to default_page_types
        defaultPageTypes = list(siteProperties.getProperty('default_page_types'))
        if 'ImageMag' in defaultPageTypes:
            defaultPageTypes.remove('ImageMag')
            siteProperties.manage_changeProperties(default_page_types = defaultPageTypes)

    return out.getvalue()
