# -*- coding: utf8 -*- 
"""make Magazine layout a Product"""
__author__  = 'nicolas laurance <nlaurance@zindep.com>'

from Products.CMFCore import utils, DirectoryView
from Products.Archetypes.public import process_types
from Products.Archetypes import listTypes

# Get configuration data, permissions
from Products.ImageMag.config import *

# Register skin directories so they can be added to portal_skins
DirectoryView.registerDirectory('skins', GLOBALS)
DirectoryView.registerDirectory('skins/imagemag', GLOBALS)

def initialize(context):

    # Import the type, which results in registerType() being called
    from ImageMag import ImageMag

    # initialize the content, including types and add permissions
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = DEFAULT_ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)
